/* Sistemas Integrados TECNISA

Nome: DTULTATU_REGIMEBEM

Descrio:

Atualiza a data de ultima atualizao da tabela REGIMEBEM

Criao:
15/01/2009 Frederico Gonalves Moreira da Costa
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_REGIMEBEM' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_REGIMEBEM
GO

CREATE TRIGGER DTULTATU_REGIMEBEM
ON REGIMEBEM
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'REGIMEBEM',NULL,'CDEMPRESA='+CDEMPRESA+';'+'CDREGIMEBEM='+CDREGIMEBEM+';',
                               GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE REGIMEBEM
      SET DTULTATURBEM = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(REGIMEBEM.CDEMPRESA,0) = ISNULL(INSERTED.CDEMPRESA,0)) AND
            (ISNULL(REGIMEBEM.CDREGIMEBEM,0) = ISNULL(INSERTED.CDREGIMEBEM,0)) AND
            (ISNULL(REGIMEBEM.NMREGIMEBEM,0) = ISNULL(INSERTED.NMREGIMEBEM,0)) AND
            (ISNULL(REGIMEBEM.NMABREVREGBEM,0) = ISNULL(INSERTED.NMABREVREGBEM,0)) AND
            (ISNULL(REGIMEBEM.IDDEPREGBEM,0) = ISNULL(INSERTED.IDDEPREGBEM,0)) AND
            (ISNULL(REGIMEBEM.DSOBSREGBEM,0) = ISNULL(INSERTED.DSOBSREGBEM,0)) AND
            (ISNULL(REGIMEBEM.CDOPERATURBEM,0) = ISNULL(INSERTED.CDOPERATUCLBEM,0));
   END;
END;
GO