/***********************************************************************************
****    Procedure para calculo do Imposto por efetivo lancado(Gesto Hospitalar), utilizada pela ******
****  rotina de gerao do demonstrativo de resultado operacional             ******
************************************************************************************

Criado em  : 12/06/2007
       Por : Alessandra Cristina

 @C:\WEB_411\SQL\END_CONV\ORACLE\0005_GERSTPO_IMPOSTOROP_RELGESHOSP.SQL
*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'IMPOSTOROP_RELGESHOSP'   AND
	        TYPE   = 'P' 			               AND
	        U.UID  = O.UID             		      AND
	        U.NAME = USER)

  DROP PROCEDURE IMPOSTOROP_RELGESHOSP
  GO

CREATE PROCEDURE IMPOSTOROP_RELGESHOSP  @P_CDFILIAL        VARCHAR(04),
                                        @P_DATAINI         DATETIME,
                                        @P_DATAFIM         DATETIME,
                                        @P_NRAPURACGD      VARCHAR(10),
                                        @P_NRROPFIL        VARCHAR(10),
                                        @P_NRLANCROP       VARCHAR(10),
                                        @P_NRITLANCROP     VARCHAR(10),
                                        @P_CDCLIENTEAPGD   VARCHAR(21),
                                        @P_DTAPURACFATGD   DATETIME,
                                        @P_CDSERVFILIAPGD  VARCHAR(05)

AS
   DECLARE @V_IDENDCFOP         VARCHAR(01);
   DECLARE @V_CDGRUPOFISC       VARCHAR(03);
   DECLARE @V_TIPOOPER          VARCHAR(02);
   DECLARE @V_CDEMPRESA         VARCHAR(02);
   DECLARE @V_CDINSCESTA        VARCHAR(16);
   DECLARE @V_PAISORIG          VARCHAR(04);
   DECLARE @V_ESTAORIG          VARCHAR(02);
   DECLARE @V_MUNIORIG          VARCHAR(04);
   DECLARE @V_PAISDEST          VARCHAR(04);
   DECLARE @V_ESTADEST          VARCHAR(02);
   DECLARE @V_MUNIDEST          VARCHAR(04);
   DECLARE @V_NRALIQTEMP        VARCHAR(14);
   DECLARE @V_NRLANCTONF        VARCHAR(20);
   DECLARE @V_IDENDEMIS         VARCHAR(01);
   DECLARE @V_IDTRIMPSTII       VARCHAR(01);
   DECLARE @V_PARDEDTMP         DOUBLE PRECISION;
   DECLARE @V_PREDBCTMP         DOUBLE PRECISION;
   DECLARE @V_ALIQUTMP          DOUBLE PRECISION;
   DECLARE @V_TRATIMPST         VARCHAR(01);
   DECLARE @V_PBCSUBTRIB        DOUBLE PRECISION;
   DECLARE @V_IDPMCBASECAL      VARCHAR(01);
   DECLARE @V_CDIMPOSTRIB       VARCHAR(02);
   DECLARE @V_IDVRIMPSTRIB      VARCHAR(01);
   DECLARE @V_VRMAXVENDA        DOUBLE PRECISION;
   DECLARE @V_VRPEMAXVENDA      DOUBLE PRECISION;
   DECLARE @V_TAXABASECALC      DOUBLE PRECISION;
   DECLARE @V_TAXAALIQUOTA      DOUBLE PRECISION;
   DECLARE @V_TAXABCSUBSTR      DOUBLE PRECISION;
   DECLARE @V_BASECALCIT        DOUBLE PRECISION;
   DECLARE @V_PERDBCALC         DOUBLE PRECISION;
   DECLARE @V_IMPOSTOIT         DOUBLE PRECISION;
   DECLARE @V_BASECALCTO        DOUBLE PRECISION;
   DECLARE @V_BASEVLRMAX        DOUBLE PRECISION;
   DECLARE @V_CALCVLRMAX        DOUBLE PRECISION;
   DECLARE @V_IMPOSTOTAL        DOUBLE PRECISION;
   DECLARE @V_NRSEQRELACIT      VARCHAR(10);
   DECLARE @V_TEXT              VARCHAR(50);
   DECLARE @V_CDFILIALAPGD      VARCHAR(04);
   DECLARE @V_CDCLIENTEAPGD     VARCHAR(21);
   DECLARE @V_CDSERVFILIAPGD    VARCHAR(05);
   DECLARE @V_CDARVPROD         VARCHAR(20);
   DECLARE @V_DTAPURACFATGD     DATETIME;
   DECLARE @V_NRAPURACGD        VARCHAR(10);
   DECLARE @V_CDPRODUTOAPGD     VARCHAR(20);
   DECLARE @V_NREFETIVOSAPGD    VARCHAR(10);
   DECLARE @V_VRPRECUNITAPGD    DOUBLE PRECISION;
   DECLARE @V_VRFATUR           DOUBLE PRECISION;
   DECLARE @V_CDIMPOTEMP        VARCHAR(10);
   DECLARE @V_CDFISCTEMP        VARCHAR(10); 
   DECLARE @V_IDTRATIMPTMP      VARCHAR(10);
   DECLARE @V_IDUTMUNIORIG      VARCHAR(10); 
   DECLARE @V_IDCONSISTENT      VARCHAR(10); 
   DECLARE @V_IDIMPORECUP       VARCHAR(10);
   DECLARE @V_IDTRATIMPO        VARCHAR(10);
   DECLARE @V_IDUTPADRROP        VARCHAR(1);
   DECLARE @V_IDUTPADRROPFIL     VARCHAR(1);
   DECLARE @V_CDFILCENTPME       VARCHAR(4);
   DECLARE @V_IDFILIALAGRROP     VARCHAR(1);
   DECLARE @V_FILIALPAR          VARCHAR(4);
   DECLARE @V_DTEFETDIET        DATETIME;
   DECLARE @V_IDINTEREST        VARCHAR(1);
   DECLARE @V_NRINSCSUFRAMA     VARCHAR(09);
BEGIN

   SET @V_TIPOOPER      = '01';
   SET @V_NRSEQRELACIT  = '0';

   SELECT @V_IDUTPADRROP = IDUTPADRROP
   FROM PARAMGERAL G;

   SELECT @V_IDUTPADRROPFIL = IDUTPADRROPFIL,
          @V_CDFILCENTPME   = CDFILCENTPME
   FROM FILIAL F LEFT JOIN PARFILIALROP P ON
                     P.CDFILIAL = F.CDFILIAL
   WHERE
      F.CDFILIAL  = @P_CDFILIAL;

   IF (@V_IDUTPADRROP = 'S' OR @V_IDUTPADRROPFIL = 'S') BEGIN
      SET @V_FILIALPAR = 'P';
   END
   ELSE BEGIN
      IF @V_CDFILCENTPME IS NULL BEGIN
         SET @V_FILIALPAR = @P_CDFILIAL;
      END
      ELSE BEGIN
         SELECT @V_IDFILIALAGRROP = ISNULL(MAX(IDFILIALAGRROP),'N')
         FROM PARFILIALROP
         WHERE CDFILIAL = @V_CDFILCENTPME;

         IF @V_IDFILIALAGRROP = 'S' BEGIN
            SET @V_FILIALPAR = @V_CDFILCENTPME;
         END
         ELSE BEGIN
            SET @V_FILIALPAR = @P_CDFILIAL;
         END;
      END;
   END;


   SELECT @V_IDENDCFOP  = ISNULL(MAX(IDENDCFOPFIL),'I'),
          @V_CDEMPRESA  = MAX(CDEMPRESA),
          @V_CDINSCESTA = MAX(CDINSCESTA)
   FROM FILIAL
   WHERE CDFILIAL = @P_CDFILIAL;

   SET @V_TEXT = 'LANCNF/FILIAL'+@P_CDFILIAL;

   EXEC NOVO_CODIGO_SC @V_TEXT, @P_SEQUENCIAL = @V_NRLANCTONF OUTPUT, @P_QTDE = 1;

   SET @V_NRLANCTONF = SUBSTRING(@V_NRLANCTONF, 10, 10);

   DECLARE C_FATURA CURSOR FOR
                    SELECT E.CDFILIAL, E.CDCLIENTE, E.DTEFETDIET, E.CDSERVFILI, CDARVPROD,
                           S.CDPRODUTO, E.QTCOMEFETDIE,
                           ROUND(TEKNISA.UTIL_APURAC.CalcValrServ(E.CDFILIAL, E.CDCLIENTE, E.CDSERVFILI,
                                                              DTEFETDIET, NULL) * E.QTCOMEFETDIE,2) AS VRFATUR
                      FROM PRODUTO P, EFETDIET E
                      LEFT JOIN SERVICO S
                        ON E.CDFILIAL    = S.CDFILIAL
                       AND E.CDSERVFILI  = S.CDSERVFILI
                     WHERE E.CDFILIAL    = @P_CDFILIAL
                       AND E.DTEFETDIET BETWEEN @P_DATAINI AND @P_DATAFIM
                       AND S.CDPRODUTO  = P.CDPRODUTO
                       AND E.CDCLIENTE  = @P_CDCLIENTEAPGD
                       AND E.DTEFETDIET = @P_DTAPURACFATGD
                       AND S.CDSERVFILI = @P_CDSERVFILIAPGD;
   OPEN C_FATURA;
   FETCH NEXT FROM C_FATURA INTO @V_CDFILIALAPGD, @V_CDCLIENTEAPGD, @V_DTEFETDIET, @V_CDSERVFILIAPGD,
                                 @V_CDARVPROD, @V_CDPRODUTOAPGD, @V_NREFETIVOSAPGD, @V_VRFATUR; 

   WHILE (@@FETCH_STATUS = 0)   BEGIN

      SELECT @V_IDENDEMIS = ISNULL(MAX(IDENDEMISCLI), 'P')
        FROM CLIENTE
       WHERE (CDCLIENTE = @V_CDCLIENTEAPGD);

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @V_CDEMPRESA
            AND CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS),
                @V_ESTAORIG = MAX(SGESTADO),
                @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM ENDEFILI
          WHERE (CDFILIAL     = @V_CDFILIALAPGD)
            AND (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      SELECT @V_PAISDEST = MAX(CDPAIS),
             @V_ESTADEST = MAX(SGESTADO),
             @V_MUNIDEST = MAX(CDMUNICIPIO)
        FROM ENDECLIE
       WHERE (CDCLIENTE    = @V_CDCLIENTEAPGD) AND
             (IDTPENDECLIE = @V_IDENDEMIS);

      SET @V_IDINTEREST = 'N';
      IF (@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG) BEGIN
         SET @V_IDINTEREST = 'S';
      END;

      EXEC CONSULTA_GRUPOFISCAL 'C', @V_CDCLIENTEAPGD, @V_CDFILIALAPGD, 'S', @V_TIPOOPER, @V_CDGRUPOFISC;

      EXEC CONSULTA_INCIDENCIA 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_TIPOOPER, @P_CDFILIAL, @V_NRLANCTONF, @V_CDGRUPOFISC, NULL, @V_IDINTEREST;

      SET @V_IMPOSTOTAL = 0;
      DECLARE C_INCIDENCIA CURSOR FOR
                          SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                  IDCONSISTENT, IDIMPORECUP, IP.IDTRATIMPO
                            FROM INCITEMP IT, IMPOSTO IP, IMPOSTOROP IR
                           WHERE (IT.NRINCITEMP = @P_CDFILIAL+@V_NRLANCTONF)
                             AND (IP.CDIMPOSTO  = IT.CDIMPOTEMP)
                             AND (IP.IDPRODNOTA = 'P')
                             AND (IR.CDFILIAL   = @V_FILIALPAR)
                             AND (CDIMPOTEMP    = IR.CDIMPOSTO)
                             AND (IDTPIMPOSTOROP = 'FE')
                           ORDER BY CDIMPOTEMP;

      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_CDIMPOTEMP,   @V_CDFISCTEMP,   @V_IDTRATIMPTMP,
                                        @V_IDUTMUNIORIG, @V_IDCONSISTENT, @V_IDIMPORECUP,
                                        @V_IDTRATIMPO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @V_IDUTMUNIORIG = 'D' BEGIN
            /* CONSIDERA O MUNICIPIO DE DESTINO */
            EXEC CONSULTA_ALIQUOTA @V_CDIMPOTEMP, 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIDEST, @V_VRFATUR, @V_DTEFETDIET,
                                   @P_CDFILIAL, @V_NRLANCTONF, @V_CDGRUPOFISC, @V_TIPOOPER;
         END
         ELSE BEGIN
           /* CONSIDERA O MUNICIPIO DE ORIGEM */
            EXEC CONSULTA_ALIQUOTA @V_CDIMPOTEMP, 'S', @V_CDEMPRESA, @V_CDARVPROD, @V_CDINSCESTA, @V_PAISORIG,
                                   @V_ESTAORIG, @V_PAISDEST, @V_ESTADEST, @V_MUNIORIG, @V_VRFATUR, @V_DTEFETDIET,
                                   @P_CDFILIAL, @V_NRLANCTONF, @V_CDGRUPOFISC, @V_TIPOOPER;
         END;

         SET @V_NRALIQTEMP = 0;
         SET @V_PARDEDTMP  = 0;
         SET @V_PREDBCTMP  = 0;
         SET @V_ALIQUTMP   = 0;
         SET @V_IMPOSTOIT  = 0;


            SELECT @V_NRALIQTEMP = ISNULL(MAX(NRALIQTEMP),0),  @V_PARDEDTMP  = ISNULL(MAX(VRPARDEDTMP),0),
                   @V_PREDBCTMP  = ISNULL(MAX(VRPREDBCTMP),0), @V_ALIQUTMP   = ISNULL(MAX(VRALIQUTMP),0),
                   @V_TRATIMPST  = ISNULL(MAX(IDTRIMPSTTMP),'0'),@V_PBCSUBTRIB = ISNULL(MAX(VRPBCSTTMP),0),
                   @V_IDPMCBASECAL = ISNULL(MAX(IDPMCBSCALTMP), 'S')
              FROM ALIQTEMP
             WHERE (NRALIQTEMP = @P_CDFILIAL+@V_NRLANCTONF);
         END;

         SELECT @V_CDIMPOSTRIB  = MAX(CDIMPOSTO),
                @V_IDVRIMPSTRIB = MAX(IDVRIMPSTRIB)
         FROM IMPOSTO
         WHERE CDIMPOSTRIB = @V_CDIMPOTEMP;


         SET @V_TAXABASECALC = (100 - @V_PREDBCTMP)/100;
         SET @V_TAXAALIQUOTA = (@V_ALIQUTMP/100);
         SET @V_TAXABCSUBSTR = 1 + (@V_PBCSUBTRIB/100);
         SET @V_BASECALCIT   = @V_VRFATUR * @V_TAXABASECALC;

         SET @V_PERDBCALC    = 100 - @V_PREDBCTMP;

         IF @V_PBCSUBTRIB > 0 BEGIN
            SET @V_BASECALCIT = (@V_BASECALCIT * @V_TAXABCSUBSTR);
            SET @V_PREDBCTMP  = @V_PBCSUBTRIB;
            SET @V_PERDBCALC  = 0;
         END;

         SET @V_BASEVLRMAX   = 0;
         SET @V_VRPEMAXVENDA = 0;
         SET @V_VRMAXVENDA   = 0;
         SET @V_CALCVLRMAX   = 0;

         SELECT @V_NRINSCSUFRAMA = MAX(NRINSCSUFRAMACL)
              FROM CLIENTE
             WHERE (CDCLIENTE = @V_CDCLIENTEAPGD);

         IF @V_NRINSCSUFRAMA IS NULL BEGIN /*Verifica se h Inscrio Suframa cadastrado p o Cliente*/
            SELECT @V_VRMAXVENDA = ISNULL(MAX(VRMAXVENDA),0),
                   @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0)
              FROM VRMAXVENPROD A
             WHERE (CDPAIS   = @V_PAISDEST) AND
                   (SGESTADO = @V_ESTADEST) AND
                   (A.CDPRODUTO = @V_CDPRODUTOAPGD);
         END
         ELSE BEGIN
            SELECT @V_VRMAXVENDA = ISNULL(MAX(VRMAXVENDA),0),
                   @V_VRPEMAXVENDA = ISNULL(MAX(VRPEMAXVENDA),0)
              FROM VRMAXVENPROD A
             WHERE (CDPAIS   = '0055') AND
                   (SGESTADO = 'SF'  ) AND
                   (A.CDPRODUTO = @V_CDPRODUTOAPGD);
         END;

         IF @V_VRMAXVENDA IS NOT NULL BEGIN
            SET @V_CALCVLRMAX = (@V_NREFETIVOSAPGD * @V_VRMAXVENDA) * (@V_VRPEMAXVENDA/100);
            SET @V_BASEVLRMAX = @V_CALCVLRMAX;
         END;

         IF @V_CDIMPOSTRIB IS NULL BEGIN
            SET @V_BASECALCTO  = @V_BASECALCIT;
            SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
         END
         ELSE BEGIN
            /*Se o parametro de "Utiliza PMC" estiver marcado eu comparo o percentual de majorao com o valor maximo
            de venda e o maior entra na base de calculo. Se o parametro estiver desmarcado sempre sera utilizado o percentual de
            majorao */
            IF ISNULL(@V_IDPMCBASECAL, 'S') = 'S' BEGIN
               IF @V_BASECALCIT > @V_BASEVLRMAX BEGIN
                  SET @V_BASECALCTO  = @V_BASECALCIT;
                  SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;
               END
               ELSE BEGIN
                  SET @V_BASECALCTO  = @V_BASEVLRMAX;
                  SET @V_IMPOSTOIT   = (@V_BASEVLRMAX * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

               END;
            END
            ELSE BEGIN
               SET @V_BASECALCTO  = @V_BASECALCIT;
               SET @V_IMPOSTOIT   = (@V_BASECALCIT * @V_TAXAALIQUOTA) - @V_PARDEDTMP;

            END;
         END;

         IF @V_CDIMPOSTRIB IS NULL BEGIN
            SET @V_IDTRIMPSTII = '';
         END
         ELSE BEGIN
            SET @V_IDTRIMPSTII = @V_TRATIMPST;
         END;

         IF (@V_IMPOSTOIT < 0) BEGIN
            SET @V_IMPOSTOIT = 0;
         END;

         IF (@V_ALIQUTMP = 0) AND (@V_IMPOSTOIT = 0) BEGIN
            SET @V_BASECALCTO = 0;
         END;

         IF @V_IDTRATIMPO = 'D' BEGIN
            SET @V_IMPOSTOTAL = - ROUND(@V_IMPOSTOIT,2);
         END
         ELSE BEGIN
            SET @V_IMPOSTOTAL = ROUND(@V_IMPOSTOIT,2);
         END;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = @P_CDFILIAL+@V_NRLANCTONF;

         SET @V_NRSEQRELACIT = @V_NRSEQRELACIT + 1;

         INSERT INTO ITRELACITROP
            (CDFILIAL,  NRROPFILIAL, NRLANCROP, NRITLANCROP, NRSEQRELACITROP,
             CDITRELITROP, QTITRELITROP, VRITRELITROP)
         VALUES
            (@P_CDFILIAL,  @P_NRROPFIL, @P_NRLANCROP, @P_NRITLANCROP, @V_NRSEQRELACIT,
             @V_CDIMPOTEMP, 0, CASE @V_IDTRATIMPO WHEN 'D' THEN -1 ELSE 1 END * @V_IMPOSTOTAL);

      FETCH NEXT FROM C_INCIDENCIA INTO @V_CDIMPOTEMP,   @V_CDFISCTEMP,   @V_IDTRATIMPTMP,
                                        @V_IDUTMUNIORIG, @V_IDCONSISTENT, @V_IDIMPORECUP,
                                        @V_IDTRATIMPO;

      END;
      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE INCITEMP
      WHERE NRINCITEMP = @P_CDFILIAL + @V_NRLANCTONF;

   FETCH NEXT FROM C_FATURA INTO @V_CDFILIALAPGD, @V_CDCLIENTEAPGD, @V_DTEFETDIET, @V_CDSERVFILIAPGD,
                                 @V_CDARVPROD,@V_CDPRODUTOAPGD, @V_NREFETIVOSAPGD, @V_VRFATUR;
   END;
   CLOSE C_FATURA;
   DEALLOCATE C_FATURA;

GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTOROP_RELGESHOSP','4.11.358';
GO

